RIMFu = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0", "AceDB-2.0");
RIMFu:RegisterDB("RIMFuDB");
RIMFu.name = "Raid Invite Manager";

RIMFu.defaultPosition = "LEFT";
RIMFu.cannotDetachTooltip = true;
RIMFu.canHideText = true;
RIMFu.clickableTooltip = true;
RIMFu.defaultMinimapPosition = 200;

RIMFu.hasIcon = "Interface\\Icons\\Spell_Nature_GroundingTotem";

local Tablet = AceLibrary("Tablet-2.0");
local Dewdrop = AceLibrary("Dewdrop-2.0");

function RIMFu:OnClick()
        RIM.UIShowRaid(1);
end;

function RIMFu:OnTextUpdate()
        if (RIM_NewVersion > RIMOptions["Version"]) then
                RIMFu:SetText("RIM - "..RIML[RIM_Locale]["New"]);
        else
                RIMFu:SetText("RIM");
        end;
end;

function RIMFu:OnMenuRequest(level, value)
        if (level == 1) then
                if (RIM_NewVersion > RIMOptions["Version"]) then
                        Dewdrop:AddLine(
                                'text', RIML[RIM_Locale]["Versiontext"]..RIM_NewVersion,
                                'hasArrow', true,
                                'hasEditBox', true,
                                'tooltipTitle', RIML[RIM_Locale]["VersiontooltipTitle"],
                                'tooltipText', RIML[RIM_Locale]["VersiontooltipText"],
                                'editBoxText', "http://www.wowinterface.com/downloads/info7992-RaidInviteManager.html"
                        )
                        Dewdrop:AddLine();
                end;
                Dewdrop:AddLine(
                        'text', RIML[RIM_Locale]["RIMOptionsShowUI"],
                        'func', function() RIM.UIShowRaid(1) end
                )
                if (RIMOptions["HideMenu"] == "On") then
                        Dewdrop:AddLine(
                                'text', RIML[RIM_Locale]["Hide Raid List"],
                                'checked', true,
                                'tooltipTitle', RIML[RIM_Locale]["Hide Raid List"],
                                'tooltipText', RIML[RIM_Locale]["HideRaidListTooltip"],
                                'func', function() RIMOptions["HideMenu"] = "Off" end
                        )
                else
                        Dewdrop:AddLine(
                                'text', RIML[RIM_Locale]["Hide Raid List"],
                                'checked', false,
                                'tooltipTitle', RIML[RIM_Locale]["Hide Raid List"],
                                'tooltipText', RIML[RIM_Locale]["HideRaidListTooltip"],
                                'func', function() RIMOptions["HideMenu"] = "On" end
                        )
                end;
                Dewdrop:AddLine();
                if (RIMOptions["AutoConvert"] == 1) then
                        Dewdrop:AddLine(
                                'text', RIML[RIM_Locale]["Auto-Convert to Raid"],
                                'checked', true,
                                'tooltipTitle', RIML[RIM_Locale]["Auto-Convert to Raid"],
                                'tooltipText', RIML[RIM_Locale]["ConverttoRaidTooltip"],
                                'func', function() RIMOptions["AutoConvert"] = 0 end
                        )
                else
                        Dewdrop:AddLine(
                                'text', RIML[RIM_Locale]["Auto-Convert to Raid"],
                                'checked', false,
                                'tooltipTitle', RIML[RIM_Locale]["Auto-Convert to Raid"],
                                'tooltipText', RIML[RIM_Locale]["ConverttoRaidTooltip"],
                                'func', function() RIMOptions["AutoConvert"] = 1 end
                        )
                end;
                if (RIMOptions["AutoPromote"] == 1) then
                        Dewdrop:AddLine(
                                'text', RIML[RIM_Locale]["Auto-Promote to Assist"],
                                'checked', true,
                                'tooltipTitle', RIML[RIM_Locale]["Auto-Promote to Assist"],
                                'tooltipText', RIML[RIM_Locale]["PromotetoAssistTooltip"],
                                'func', function() RIMOptions["AutoPromote"] = 0 end
                        )
                else
                        Dewdrop:AddLine(
                                'text', RIML[RIM_Locale]["Auto-Promote to Assist"],
                                'checked', false,
                                'tooltipTitle', RIML[RIM_Locale]["Auto-Promote to Assist"],
                                'tooltipText', RIML[RIM_Locale]["PromotetoAssistTooltip"],
                                'func', function() RIMOptions["AutoPromote"] = 1 end
                        )
                end;
                if (RIMOptions["AutoInvite"] == 1) then
                        Dewdrop:AddLine(
                                'text', RIML[RIM_Locale]["Auto-Invite on Login"],
                                'checked', true,
                                'tooltipTitle', RIML[RIM_Locale]["Auto-Invite on Login"],
                                'tooltipText', RIML[RIM_Locale]["AutoInviteTooltip"],
                                'func', function() RIMOptions["AutoInvite"] = 0 end
                        )
                else
                        Dewdrop:AddLine(
                                'text', RIML[RIM_Locale]["Auto-Invite on Login"],
                                'checked', false,
                                'tooltipTitle', RIML[RIM_Locale]["Auto-Invite on Login"],
                                'tooltipText', RIML[RIM_Locale]["AutoInviteTooltip"],
                                'func', function() RIMOptions["AutoInvite"] = 1 end
                        )
                end;
                Dewdrop:AddLine(
                        'text', RIML[RIM_Locale]["Auto-Invite Timeout"],
                        'hasArrow', true,
                        'hasSlider', true,
                        'sliderMin', 15,
                        'sliderMax', 60,
                        'sliderStep', 1,
                        'sliderValue', RIMOptions["InviteTimeout"],
                        'sliderFunc', function(value) RIMOptions["InviteTimeout"] = value end,
                        'tooltipTitle', RIML[RIM_Locale]["Auto-Invite Timeout"],
                        'tooltipText', RIML[RIM_Locale]["InviteTimeoutTooltip"]
                )
                Dewdrop:AddLine(
                        'text', RIML[RIM_Locale]["Pre-Invite Message"],
                        'hasArrow', true,
                        'hasEditBox', true,
                        'tooltipTitle', RIML[RIM_Locale]["Pre-Invite Message"],
                        'tooltipText', RIML[RIM_Locale]["PreInviteTooltip"],
                        'editBoxText', RIMOptions["InviteGMsg"],
                        'editBoxFunc', function(text) RIMOptions["InviteGMsg"] = text end
                )
                Dewdrop:AddLine();
                Dewdrop:AddLine(
                        'text', RIML[RIM_Locale]["Your Characters"],
                        'hasArrow', true,
                        'value', 1
                )
                Dewdrop:AddLine(
                        'text', RIML[RIM_Locale]["Broadcast Throttle"],
                        'hasArrow', true,
                        'hasSlider', true,
                        'sliderMin', 0.1,
                        'sliderMax', 2,
                        'sliderStep', 0.1,
                        'sliderValue', RIMOptions["BroadcastThrottle"],
                        'sliderFunc', function(value) RIMOptions["BroadcastThrottle"] = value end,
                        'tooltipTitle', RIML[RIM_Locale]["Broadcast Throttle"],
                        'tooltipText', RIML[RIM_Locale]["ThrottleTooltip"]
                )
                Dewdrop:AddLine();
                Dewdrop:AddLine(
                		'text', RIML[RIM_Locale]["Change Localization"],
                		'hasArrow', true,
                		'value', 2
                )
                if RIMOptions["phpDebug"] then
                        Dewdrop:AddLine(
                                'text', RIML[RIM_Locale]["Debug Mode"],
                                'checked', true,
                                'tooltipTitle', RIML[RIM_Locale]["Debug Mode"],
                                'tooltipText', RIML[RIM_Locale]["DebugModeTooltip"],
                                'func', function() RIMOptions["phpDebug"] = nil end
                        )
                        Dewdrop:AddLine(
                                'text', RIML[RIM_Locale]["Display All User Versions"],
                                'tooltipTitle', RIML[RIM_Locale]["DisplayTooltipText"],
                                'tooltipText', RIML[RIM_Locale]["DisplayTooltip"],
                                'func', function() RIM_TempDisplayVersion = 20; RIM.Print("hidden", "guild", "V"..RIMOptions["Version"]) end
                        )
                else
                        Dewdrop:AddLine(
                                'text', RIML[RIM_Locale]["Debug Mode"],
                                'checked', false,
                                'tooltipTitle', RIML[RIM_Locale]["Debug Mode"],
                                'tooltipText', RIML[RIM_Locale]["DebugModeTooltip"],
                                'func', function() RIMOptions["phpDebug"] = 1 end
                        )
                end;
                Dewdrop:AddLine();
        elseif (level == 2) and (value == 1) then
                Dewdrop:AddLine(
                        'text', RIML[RIM_Locale]["Click to Remove"],
                        'isTitle', true
                )
                Dewdrop:AddLine();
                for i=1,getn(RIMOptions["YourChars"]) do
                        nextName,nextClass = strsplit("-", RIMOptions["YourChars"][i]);
                        if (nextClass == "Death Knight") then
								nextClass = "DeathKnight";
                        end;
                        classColor = RAID_CLASS_COLORS[string.upper(nextClass)];
                        Dewdrop:AddLine(
                                'text', nextName,
                                'textR', classColor.r,
                                'textG', classColor.g,
                                'textB', classColor.b,
                                'func', function() tremove(RIMOptions["YourChars"], i) end
                        )
                end;
        elseif (level == 2) and (value == 2) then
        		for locales, values in pairs(RIML) do
        				if (locales == RIM_Locale) then
		        				Dewdrop:AddLine(
        								'text', RIML[locales][locales],
        								'isTitle', true
        						)
        				else
        						Dewdrop:AddLine(
		        						'text', RIML[locales][locales],
        								'func', function() RIM_Locale = locales end
        						)
        				end;
        		end;
        end;
end;

function RIMFu:OnTooltipUpdate()
        if (RIMOptions["HideMenu"] == "On") then
                if not RIM_FullMenu then
                        local raidtip = Tablet:AddCategory(
                                'columns', 1,
                                'child_textR', 1,
                                'child_textG', 1,
                                'child_textB', 1
                        )
                        raidtip:AddLine(
                                'text', RIML[RIM_Locale]["Click to Display Raid List"],
                                'func', function() RIM_FullMenu = 1; RIMFu:UpdateTooltip() end
                        )
                        return;
                end;
                RIM_FullMenu = nil;
        end;
        if (RIM_NewVersion > RIMOptions["Version"]) then
                local raidtip = Tablet:AddCategory(
                        'columns', 1,
                        'child_textR', 1,
                        'child_textG', 0,
                        'child_textB', 0
                )
                raidtip:AddLine(
                        'text', RIML[RIM_Locale]["Versiontext"]..RIM_NewVersion
                )
        end;

-- phpRaid_Data["file_stamp"]    20071221025527
        local tipDateStamp = phpRaid_Data["file_stamp"];
        tipYear = strsub(tipDateStamp, 1, 4);
        tipMonth = strsub(tipDateStamp, 5, 6);
        tipDate = strsub(tipDateStamp, 7, 8);
        tipHour = strsub(tipDateStamp, 9, 10);
        tipMinute = strsub(tipDateStamp, 11, 12);
        local raidtip = Tablet:AddCategory(
                'columns', 2,
                'child_textR', 0,
                'child_textG', 1,
                'child_textB', 0.49,
                'child_text2R', 0,
                'child_text2G', 1,
                'child_text2B', 0.49
        )
        raidtip:AddLine(
                'text', RIML[RIM_Locale]["Data Updated:"],
                'text2', tipMonth.."/"..tipDate.."/"..tipYear..RIML[RIM_Locale][" at "]..tipHour..":"..tipMinute
        )
        if RIMOptions["phpDebug"] then
                local raidtip = Tablet:AddCategory(
                        'columns', 3,
                        'child_textR', 1,
                        'child_textG', 1,
                        'child_textB', 1,
                        'child_text2R', 1,
                        'child_text2G', 1,
                        'child_text2B', 1
                )
                raidtip:AddLine(
                        'text', "phpLeader",
                        'text2', "LeadTimer",
                        'text3', "RawTimer"
                )
                timeMin = floor(phpLeaderTimer / 60);
                timeSec = floor(phpLeaderTimer) - floor(phpLeaderTimer / 60) * 60;
                raidtip:AddLine(
                        'text', phpLeader,
                        'text2', timeMin.."m "..timeSec.."sec",
                        'text3', phpLeaderTimer
                )
        end;
        if RIM_SyncMax and (tonumber(RIM_SyncMin) < tonumber(RIM_SyncMax)) then
                local raidtip = Tablet:AddCategory(
                        'columns', 5,
                        'child_textR', 1,
                        'child_textG', 0,
                        'child_textB', 0
                )
                raidtip:AddLine(
                        'text', RIML[RIM_Locale]["Data Updating. Please wait...."]
                )
                if (tonumber(RIM_SyncMin) < tonumber(RIM_SyncMax)) then
                        raidtip:AddLine(
                                'text', RIML[RIM_Locale]["Sync:  "]..floor(tonumber(RIM_SyncMin)/tonumber(RIM_SyncMax)*100).."%",
                                'textR', 1,
                                'textG', 1,
                                'textB', 1
                        )
                end;
                return;
        end;
        local raidtip = Tablet:AddCategory(
                'columns', 5,
                'child_textR', 0,
                'child_textG', 1,
                'child_textB', 0.49,
                'child_text2R', 0,
                'child_text2G', 1,
                'child_text2B', 0.49,
                'child_text3R', 0,
                'child_text3G', 1,
                'child_text3B', 0.49
        )
        raidtip:AddLine(
                'text', RIML[RIM_Locale]["Signed Up"],
                'text2', RIML[RIM_Locale]["Date"],
                'text3', RIML[RIM_Locale]["Time"],
                'text4', RIML[RIM_Locale]["Character"],
                'text5', RIML[RIM_Locale]["Pending Status"],
                'textR', 1,
                'textG', 1,
                'textB', 1,
                'text2R', 1,
                'text2G', 1,
                'text2B', 1,
                'text3R', 1,
                'text3G', 1,
                'text3B', 1,
                'text4R', 1,
                'text4G', 1,
                'text4B', 1,
                'text5R', 1,
                'text5G', 1,
                'text5B', 1
        )
        for i=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) do
                for z=1,11 do
                        if (getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]]) > 0) then
                                for j=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]]) do
                                        matchedName = nil;
                                        checkName = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]][j]["name"];
                                        if (strsub(checkName, 1, 1) == "*") then
                                                checkName = strsub(checkName, 2);
                                        end;
                                        for r=1,getn(RIMOptions["YourChars"]) do
                                                testName = strsub(RIMOptions["YourChars"][r], 1, strfind(RIMOptions["YourChars"][r], "-")-1);
                                                if (checkName == testName) then
                                                        matchedName = RIMOptions["YourChars"][r];
                                                end;
                                        end;
                                        if matchedName then
                                                nextLocation = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["location"];
                                                nextDate = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["date"];
                                                nextTime = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["start_time"];
                                                updateStatus = nil;
                                                charName = strsub(matchedName, 1, strfind(matchedName, "-")-1);
                                                charClass = strsub(matchedName, strfind(matchedName, "-")+1);
                                                if (phpRaidSave[RIM_myServer][RIM_myGuild]["updates"][charName]) then
                                                        if (phpRaidSave[RIM_myServer][RIM_myGuild]["updates"][charName][u]["Location"] == nextLocation) and (phpRaidSave["updates"][charName][u]["Date"] == nextDate) and (phpRaidSave["updates"][charName][u]["Time"] == nextTime) then
                                                                updateStatus = phpRaidSave[RIM_myServer][RIM_myGuild]["updates"][charName][u]["Status"];
                                                        end;
                                                end;
                                                if (charClass == "Death Knight") then
						                        		charClass = "DeathKnight";
                        						end;
                                                nextColor = RAID_CLASS_COLORS[string.upper(charClass)];
                                                if not updateStatus then updateStatus = "" end;
                                                if (updateStatus == "Cancel") then
                                                        updateColor = { ["r"] = 0, ["g"] = 1, ["b"] = 0.49 }
                                                else
                                                        updateColor = { ["r"] = 0, ["g"] = 1, ["b"] = 0.49 }
                                                end;
                                                raidtip:AddLine(
                                                        'text', nextLocation,
                                                        'text2', nextDate,
                                                        'text3', nextTime,
                                                        'text4', charName,
                                                        'text5', updateStatus,
                                                        'text4R', nextColor.r,
                                                        'text4G', nextColor.g,
                                                        'text4B', nextColor.b,
                                                        'text5R', updateColor.r,
                                                        'text5G', updateColor.g,
                                                        'text5B', updateColor.b,
                                                        'func', function() RIM.UIShowRaid(i) end
                                                )
                                        end;
                                end;
                        end;
                end;
        end;

        local raidtip = Tablet:AddCategory(
                'columns', 5,
                'child_textR', 1,
                'child_textG', 0.56,
                'child_textB', 0,
                'child_text2R', 1,
                'child_text2G', 0.56,
                'child_text2B', 0,
                'child_text3R', 1,
                'child_text3G', 0.56,
                'child_text3B', 0
        )
        raidtip:AddLine(
                'text', RIML[RIM_Locale]["Not Signed Up"],
                'text2', RIML[RIM_Locale]["Date"],
                'text3', RIML[RIM_Locale]["Time"],
                'text4', RIML[RIM_Locale]["Character"],
                'text5', RIML[RIM_Locale]["Pending Status"],
                'textR', 1,
                'textG', 1,
                'textB', 1,
                'text2R', 1,
                'text2G', 1,
                'text2B', 1,
                'text3R', 1,
                'text3G', 1,
                'text3B', 1,
                'text4R', 1,
                'text4G', 1,
                'text4B', 1,
                'text5R', 1,
                'text5G', 1,
                'text5B', 1
        )
        for i=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) do
                notInRaid = 1;
                for z=1,11 do
                        if (getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]]) > 0) then
                                for j=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]]) do
                                        matchedName = nil;
                                        checkName = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]][j]["name"];
                                        if (strsub(checkName, 1, 1) == "*") then
                                                checkName = strsub(checkName, 2);
                                        end;
                                        for r=1,getn(RIMOptions["YourChars"]) do
                                                testName = strsub(RIMOptions["YourChars"][r], 1, strfind(RIMOptions["YourChars"][r], "-")-1);
                                                if (checkName == testName) then
                                                        notInRaid = 0;
                                                end;
                                        end;
                                end;
                        end;
                end;
                if (notInRaid == 1) then
                        raidtip:AddLine(
                                'text', phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["location"],
                                'text2', phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["date"],
                                'text3', phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["start_time"],
                                'func', function() RIM.UIShowRaid(i) end
                        )
                end;
        end;
end;

RIM = {

OnLoad = function()
		if not RIM_Locale then
				RIM_Locale = "enUS";
		end;
        RIMBroadcastQueue = { };
        phpLeader = "";
        phpLeaderTimer = 60;
        phpBcLockout = 0;
        RIM_SyncMin = 0;
        RIM_SyncMax = 0;
        RIM_TempDisplayVersion = 0;
        phpLeadList = { };
        phpStatusCheck = { };
        RIM_AutoPromote = { };
        RIM_AutoPromoteTimer = 0;
        charPlusClass = UnitName("player").."-"..UnitClass("player");
        phpClasses = {
        		"deathknights",
                "druids",
                "hunters",
                "mages",
                "paladins",
                "priests",
                "rogues",
                "shaman",
                "warlocks",
                "warriors",
                "queue"
        }
        nonPhpClasses = {
        		"DeathKnight",
                "Druid",
                "Hunter",
                "Mage",
                "Paladin",
                "Priest",
                "Rogue",
                "Shaman",
                "Warlock",
                "Warrior",
                "queue"
        }

        if not RIMOptions then
                RIMOptions = { }
        end;
        if ((RIMOptions["Version"] == nil) or (RIMOptions["Version"] < 0)) then
                RIM.Print("echo", nil, RIML[RIM_Locale]["VersionSettingsResetMsg"]);
                RIMOptions = { };
                RIMOptions["Version"] = 0;
        end;
        if RIMOptions["Version"] then
        		RIM_oldVer = RIMOptions["Version"];
        else
        		RIM_oldVer = 0;
        end;
        RIMOptions["Version"] = 0.04007;
        RIM_NewVersion = RIMOptions["Version"];
        if not RIMOptions["BroadcastThrottle"] then
                RIMOptions["BroadcastThrottle"] = 0.1;
        end;
        if not RIMOptions["HideMenu"] then
                RIMOptions["HideMenu"] = "Off";
        end;
        if not RIMOptions["InviteGMsg"] then
                RIMOptions["InviteGMsg"] = RIML[RIM_Locale]["DefaultInviteMsg"];
        end;
        if not RIMOptions["AutoConvert"] then
                RIMOptions["AutoConvert"] = 1;
        end;
        if not RIMOptions["AutoPromote"] then
        		RIMOptions["AutoPromote"] = 0;
        end;
        if not RIMOptions["AutoInvite"] then
                RIMOptions["AutoInvite"] = 1;
        end;
        if not RIMOptions["InviteTimeout"] then
                RIMOptions["InviteTimeout"] = 30;
        end;
        if not RIMOptions["YourChars"] then
                RIMOptions["YourChars"] = { };
        else
                for i=1,getn(RIMOptions["YourChars"]) do
                        if (charPlusClass == RIMOptions["YourChars"][i]) then
                                charListed = 1;
                        end;
                end;
        end;
        if not charListed then
                tinsert(RIMOptions["YourChars"], charPlusClass);
        end;

        Dewdrop:Register(RIMRaid_UIRaidID,
                'children', function(level,value) RIM.RaidMenuClick(level,value) end
        )
        Dewdrop:Register(RIMRaid_TeamID,
                'children', function(level,value) RIM.TeamMenuClick(level,value) end
        )
end;

SendInitial = function()
        RIM_myServer = GetRealmName();
        RIM_myGuild = GetGuildInfo("player");
        if (RIM_oldVer < 0.04000) then
        		phpRaidSave = { };
        end;
		if not phpRaidSave then
				phpRaidSave = { };
		end;
		if not phpRaidSave[RIM_myServer] then
				phpRaidSave[RIM_myServer] = { };
		end;
        if not phpRaidSave[RIM_myServer][RIM_myGuild] then
                phpRaidSave[RIM_myServer][RIM_myGuild] = {
                        ["raids"] = { },
                        ["updates"] = { },
                        ["file_stamp"] = "0",
                }
        end;
        if not phpRaid_Data then
                phpRaid_Data = {
                        ["file_stamp"] = "0"
                }
        end;
        if not phpRaidSave[RIM_myServer][RIM_myGuild]["file_stamp"] then
                phpRaidSave[RIM_myServer][RIM_myGuild]["file_stamp"] = "0";
        end;
        if not phpRaid_Data["file_stamp"] then
                phpRaid_Data["file_stamp"] = "0";
        end;
        if ((phpRaid_Data["guild"] ~= RIM_myGuild) or (phpRaid_Data["server"] ~= RIM_myServer)) then
        		phpRaid_Data["file_stamp"] = "0"; --Trying Something Different! Should Ignore Download.
--        		return;
        end;
        if (tonumber(phpRaidSave[RIM_myServer][RIM_myGuild]["file_stamp"]) < tonumber(phpRaid_Data["file_stamp"])) then
                phpRaidSave[RIM_myServer][RIM_myGuild]["raids"] = { };
                phpRaidSave[RIM_myServer][RIM_myGuild]["file_stamp"] = "";
        else
                phpRaid_Data["file_stamp"] = phpRaidSave[RIM_myServer][RIM_myGuild]["file_stamp"];
        end;

        RIM.Print("hidden", "guild", "CheckTime "..phpRaid_Data["file_stamp"]);
        RIM.Print("hidden", "guild", "V"..RIMOptions["Version"]);
end;

UIShowRaid = function(id, checkShow)
        if not checkShow then
                ShowUIPanel(RIMRaider_Main);
        end;
        RIMRaider_MainInvite_DeathKnight:SetText(RIML[RIM_Locale]["All "]..RIML[RIM_Locale]["Death Knights"]);
        RIMRaider_MainInvite_Druid:SetText(RIML[RIM_Locale]["All "]..RIML[RIM_Locale]["Druids"]);
        RIMRaider_MainInvite_Hunter:SetText(RIML[RIM_Locale]["All "]..RIML[RIM_Locale]["Hunters"]);
        RIMRaider_MainInvite_Mage:SetText(RIML[RIM_Locale]["All "]..RIML[RIM_Locale]["Mages"]);
        RIMRaider_MainInvite_Paladin:SetText(RIML[RIM_Locale]["All "]..RIML[RIM_Locale]["Paladins"]);
        RIMRaider_MainInvite_Priest:SetText(RIML[RIM_Locale]["All "]..RIML[RIM_Locale]["Priests"]);
        RIMRaider_MainInvite_Rogue:SetText(RIML[RIM_Locale]["All "]..RIML[RIM_Locale]["Rogues"]);
        RIMRaider_MainInvite_Shaman:SetText(RIML[RIM_Locale]["All "]..RIML[RIM_Locale]["Shaman"]);
        RIMRaider_MainInvite_Warlock:SetText(RIML[RIM_Locale]["All "]..RIML[RIM_Locale]["Warlocks"]);
        RIMRaider_MainInvite_Warrior:SetText(RIML[RIM_Locale]["All "]..RIML[RIM_Locale]["Warriors"]);

        RIMRaider_MainPre_Invite:SetText(RIML[RIM_Locale]["Pre-Invite Msg"]);
        RIMRaider_MainManual_Raid:SetText(RIML[RIM_Locale]["Convert To Raid"]);
        RIMRaider_MainInvite_All:SetText(RIML[RIM_Locale]["Invite All"]);
        RIMRaider_MainQueueText:SetText(RIML[RIM_Locale]["Queue"]);
        if not phpRaidSave[RIM_myServer][RIM_myGuild]["raids"] or (getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) <= 0) then
                RIMRaid_UIRaidIDText:SetText(RIML[RIM_Locale]["Data Updating. Please wait...."]);
                RIMRaid_TeamIDText:SetText(RIML[RIM_Locale]["Data Updating. Please wait...."]);
                return;
        end;
        Ddate = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][id]["date"];
        Dtime = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][id]["start_time"];
        Dlocation = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][id]["location"];
        RIMRaid_UIRaidIDText:SetText(Dlocation.." - "..Ddate.." "..Dtime);
        RIMRaid_TeamIDText:SetText(RIML[RIM_Locale]["All Teams"].." - "..RIML[RIM_Locale]["Click to Change"]);
        RIMRaid_RaidList = { };
        RIMRaid_QueueList = { };

        RIMRaid_DisplayTeam = "Any";
        RIMRaid_RaidID = id;
        RIMRaid_RaiderOffset = 0;
        RIM.DisplayRaiders(id, RIMRaid_DisplayTeam);
        RIMRaid_QueueOffset = 0;
        RIM.DisplayQueue(id, 0);
        RIMRaider_MainQueueScrollRight:Enable();
end;

openRaidMenu = function()
        Dewdrop:Open(RIMRaid_UIRaidID);
end;

openTeamMenu = function()
        Dewdrop:Open(RIMRaid_TeamID);
end;

RaidMenuClick = function(level,value)
        if not phpRaidSave[RIM_myServer][RIM_myGuild]["raids"] or (getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) <= 0) then
                Dewdrop:AddLine(
                        'text', RIML[RIM_Locale]["Data Updating. Please wait...."]
                )
                return;
        end;
        for i=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) do
                Dewdrop:AddLine(
                        'text', phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["date"].." - "..phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["start_time"].." - "..phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["location"],
                        'closeWhenClicked', true,
                        'func', function() RIM.UIShowRaid(i) end
                )
        end;
end;

TeamMenuClick = function(level,value)
        if not phpRaidSave[RIM_myServer][RIM_myGuild]["raids"] or (getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) <= 0) then
                Dewdrop:AddLine(
                        'text', RIML[RIM_Locale]["Data Updating. Please wait...."]
                )
                return;
        end;
        phpTeamList = { };
        for z=1,10 do
                if (getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][nonPhpClasses[z]]) > 0) then
                        for j=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][nonPhpClasses[z]]) do
                                nextTeam = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][nonPhpClasses[z]][j]["team_name"]
                                existingTeam = 0;
                                for i=1,getn(phpTeamList) do
                                        if (phpTeamList[i] == nextTeam) then
                                                existingTeam = 1;
                                        end;
                                end;
                                if (existingTeam == 0) and nextTeam and (nextTeam ~= "") then
                                        tinsert(phpTeamList, nextTeam);
                                end;
                        end;
                end;
        end;
        if (getn(phpTeamList) <= 0) then
                Dewdrop:AddLine(
                        'text', RIML[RIM_Locale]["No Teams Assigned To Raid."]
                )
                return;
        end;
        Dewdrop:AddLine(
                'text', RIML[RIM_Locale]["All Teams"],
                'closeWhenClicked', true,
                'func', function() RIMRaid_DisplayTeam = "Any"; RIMRaid_TeamIDText:SetText(RIML[RIM_Locale]["All Teams"].." - "..RIML[RIM_Locale]["Click to Change"]); RIM.DisplayRaiders(RIMRaid_RaidID, "Any") end
        )
        for i=1,getn(phpTeamList) do
                Dewdrop:AddLine(
                        'text', phpTeamList[i],
                        'closeWhenClicked', true,
                        'func', function() RIMRaid_DisplayTeam = phpTeamList[i]; RIMRaid_TeamIDText:SetText(phpTeamList[i].." - "..RIML[RIM_Locale]["Click to Change"]); RIM.DisplayRaiders(RIMRaid_RaidID, phpTeamList[i]) end
                )
        end;
end;

DisplayRaiders = function(id, team, statusCheck)
		if not statusCheck then
		        phpStatusCheck = { };
		        for f=1,GetNumGuildMembers() do
                		Iname,_,_,_,_,_,_,_,Ionline,Istatus = GetGuildRosterInfo(f);
		                if Ionline then
                        		if (Istatus == "") then
		                                phpStatusCheck[Iname] = RIML[RIM_Locale]["Online"];
                        		else
		                                phpStatusCheck[Iname] = Istatus;
                        		end;
                		end;
        		end;
        		for f=1,GetNumRaidMembers() do
		                Iname = UnitName("raid"..f);
                		phpStatusCheck[Iname] = RIML[RIM_Locale]["In Group"];
        		end;
        		for f=1,GetNumPartyMembers() do
		                Iname = UnitName("party"..f);
                		phpStatusCheck[Iname] = RIML[RIM_Locale]["In Group"];
        		end;
        end;
        for z=1,10 do
                u = 1;
                for i=1,6 do
                        getglobal("RIMRaider_Main_"..nonPhpClasses[z]..i.."Text"):SetText("");
                end;
                for i=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][id][nonPhpClasses[z]]) do
                        dispName = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][id][nonPhpClasses[z]][i]["name"];
                        dispTeam = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][id][nonPhpClasses[z]][i]["team_name"];
                        if (team == "Any") or (team == dispTeam) then
                                if (strsub(dispName, 1, 1) == "*") then
                                        dispName = strsub(dispName, 2);
                                end;
                                if (u < 7) then
                                        if not phpStatusCheck[dispName] then
                                                phpColor = "|cffa7a7a7";
                                        elseif (phpStatusCheck[dispName] == RIML[RIM_Locale]["Online"]) then
                                                phpColor = "|cffffff00";
                                        elseif (phpStatusCheck[dispName] == RIML[RIM_Locale]["In Group"]) then
                                                phpColor = "|cff00ff7d";
                                        else
                                                phpColor = "|cff00e0ff";
                                        end;
                                        getglobal("RIMRaider_Main_"..nonPhpClasses[z]..u.."Text"):SetText(phpColor..dispName.."|r");
                                end;
                                u = u + 1;
                        end;
                end;
        end;
end;

DisplayQueue = function(id, offset)
        if (offset ~= 0) then
                RIMRaid_QueueOffset = RIMRaid_QueueOffset + offset;
        end;
        if (RIMRaid_QueueOffset <= 0) then
                RIMRaid_QueueOffset = 0;
                RIMRaider_MainQueueScrollLeft:Disable();
        else
                RIMRaider_MainQueueScrollLeft:Enable();
        end;
        if (RIMRaid_QueueOffset+15 >= getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][id]["queue"])) then
        		RIMRaider_MainQueueScrollRight:Disable();
        else
        		RIMRaider_MainQueueScrollRight:Enable();
        end;
        u = 1;
        m = 0;
        for i=1,15 do
                getglobal("RIMRaider_MainQueue_"..i.."Text"):SetText("");
        end;
        for i=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][id]["queue"]) do
                dispName = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][id]["queue"][i]["name"];
                if (strsub(dispName, 1, 1) == "*") then
                        dispName = strsub(dispName, 2);
                end;
                if (RIMRaid_QueueOffset <= m) then
                        if (u < 16) then
                                if not phpStatusCheck[dispName] then
                                        phpColor = "|cffa7a7a7";
                                elseif (phpStatusCheck[dispName] == RIML[RIM_Locale]["Online"]) then
                                        phpColor = "|cffffff00";
                                elseif (phpStatusCheck[dispName] == RIML[RIM_Locale]["In Group"]) then
                                        phpColor = "|cff00ff7d";
                                else
                                        phpColor = "|cff00e0ff";
                                end;
                                getglobal("RIMRaider_MainQueue_"..u.."Text"):SetText(phpColor..dispName.."|r");
                        end;
                        u = u + 1;
                end;
                m = m + 1;
        end;
end;

InviteClass = function(className)
        if not phpRaidSave[RIM_myServer][RIM_myGuild]["raids"] or (getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) <= 0) then
                return;
        end;
        checkConvert = 0;
        for z=1,10 do
                checkConvert = checkConvert + getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][nonPhpClasses[z]]);
        end;
        if (checkConvert > 5) then
           		RIM_ConvertToRaid = 1;
        end;
        if (className == "All") then
                RIM_AutoInviteActive = RIMRaid_RaidID;
                RIM_InviteTimeout = RIMOptions["InviteTimeout"]*60;
                for z=1,10 do
                        RIM.InviteClass(nonPhpClasses[z]);
                end;
                return;
        end;
        for i=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][className]) do
                dispName = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][className][i]["name"];
                dispTeam = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][className][i]["team_name"];
				userAccess = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][className][i]["access_type"];
                if (RIMRaid_DisplayTeam == "Any") or (RIMRaid_DisplayTeam == dispTeam) then
                        if (strsub(dispName, 1, 1) == "*") then
                                dispName = strsub(dispName, 2);
                        end;
                        if (dispName ~= UnitName("player")) then
                                InviteUnit(dispName);
                                if (userAccess ~= "User") then
                                   		tinsert(RIM_AutoPromote, dispName);
                                  		RIM.Print("echo", nil, "Promote: "..dispName);
                                end;
                        end;
                end;
        end;
end;

Broadcast_PreInvite = function()
        invText = string.gsub(RIMOptions["InviteGMsg"], "%%n", phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID]["location"]);
        RIM.Print("guild", nil, invText);
end;

HandleInvite = function(id, click)
		checkConvert = 0;
        for z=1,10 do
                checkConvert = checkConvert + getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][nonPhpClasses[z]]);
        end;
        if (checkConvert > 5) then
           		RIM_ConvertToRaid = 1;
        end;
		
        if (id < 200) then
        		if (id < 10) then
        				charID = tonumber(id);
        				tipClass = nonPhpClasses[1];
        		else
        		        charID = tonumber(strsub(id, 2));
		                tipClass = nonPhpClasses[tonumber(strsub(id, 1, 1))+1];
                end;
                u = 1;
                dataID = 0;
                for i=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][tipClass]) do
                        dispName = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][tipClass][i]["name"];
                        if (strsub(dispName, 1, 1) == "*") then
                                dispName = strsub(dispName, 2);
                        end;
                        if (RIMRaid_DisplayTeam == "Any") or (RIMRaid_DisplayTeam == dispTeam) then
                                if (u == charID) then
                                        dataID = i;
                                        u = u + 1;
                                else
                                        u = u + 1;
                                end;
                        end;
                end;
                if not phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][tipClass][dataID] then
                        return;
                end;
                dispName = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][tipClass][dataID]["name"];
				userAccess = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][tipClass][dataID]["access_type"];
                if (strsub(dispName, 1, 1) == "*") then
                        dispName = strsub(dispName, 2);
                end;
                if (dispName ~= UnitName("player")) then
                        InviteUnit(dispName);
                        if (userAccess ~= "User") then
                           		tinsert(RIM_AutoPromote, dispName);
                           		RIM.Print("echo", nil, "Promote: "..dispName);
                        end;
                end;
        else
                charID = tonumber(strsub(id, 2));
                u = 1;
                dataID = 0;
                for i=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID]["queue"]) do
                        dispName = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID]["queue"][i]["name"];
						userAccess = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID]["queue"][i]["access_type"];
                        if (strsub(dispName, 1, 1) == "*") then
                                dispName = strsub(dispName, 2);
                        end;
                        if (u == charID+RIMRaid_QueueOffset) then
                                InviteUnit(dispName);
		                        if (userAccess ~= "User") then
        		                   		tinsert(RIM_AutoPromote, dispName);
                		           		RIM.Print("echo", nil, "Promote: "..dispName);
                        		end;
                        end;
                        u = u + 1;
                end;
        end;
end;

ConvertToRaid = function()
		if (RIM_ConvertToRaid and (GetNumPartyMembers() > 0) and (GetNumRaidMembers() == 0)) then
				ConvertToRaid();
				RIM_ConvertToRaid = nil;
		end;
		if (getn(RIM_AutoPromote) > 0) and (RIMOptions["AutoPromote"] == 1) then
		        RIM_AutoPromoteTimer = 15;
		end;
end;

InviteTooltip = function(id)
        if not phpRaidSave[RIM_myServer][RIM_myGuild]["raids"] or (getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) <= 0) then
                return;
        end;
        GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
        if (id == 400) then
                GameTooltip:AddLine(RIMRaid_UIRaidIDText:GetText());
        elseif (id == 401) then
                GameTooltip:AddLine(RIMRaid_TeamIDText:GetText());
        elseif (id < 200) then
        		if (id < 10) then
        				charID = tonumber(id);
        				tipClass = nonPhpClasses[1];
        		else
        		        charID = tonumber(strsub(id, 2));
		                tipClass = nonPhpClasses[tonumber(strsub(id, 1, 1))+1];
                end;
                u = 1;
                dataID = 0;
                for i=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][tipClass]) do
                        dispName = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][tipClass][i]["name"];
                        if (strsub(dispName, 1, 1) == "*") then
                                dispName = strsub(dispName, 2);
                        end;
                        if (RIMRaid_DisplayTeam == "Any") or (RIMRaid_DisplayTeam == dispTeam) then
                                if (u == charID) then
                                        dataID = i;
                                        u = u + 1;
                                else
                                        u = u + 1;
                                end;
                        end;
                end;
                if not phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][tipClass][dataID] then
                        return;
                end;
                dispName = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][tipClass][dataID]["name"];
                if (strsub(dispName, 1, 1) == "*") then
                        dispName = strsub(dispName, 2);
                end;

                dispTeam = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][tipClass][dataID]["team_name"];
                dispTime = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][tipClass][dataID]["timestamp"];
                dispClass = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][tipClass][dataID]["class"];
                if not phpStatusCheck[dispName] then
                        phpColor = "|cffa7a7a7";
                        phpStatus = RIML[RIM_Locale]["Offline"];
                elseif (phpStatusCheck[dispName] == RIML[RIM_Locale]["Online"]) then
                        phpColor = "|cffffff00";
                        phpStatus = RIML[RIM_Locale]["Online"];
                elseif (phpStatusCheck[dispName] == RIML[RIM_Locale]["In Group"]) then
                        phpColor = "|cff00ff7d";
                        phpStatus = RIML[RIM_Locale]["In Group"];
                else
                        phpColor = "|cff00e0ff";
                        phpStatus = phpStatusCheck[dispName];
                end;
                if (dispTeam == "") then
                        dispTeam = RIML[RIM_Locale]["None"];
                end;
                nextColor = RAID_CLASS_COLORS[string.upper(tipClass)];
                GameTooltip:AddDoubleLine("|cffffffff"..dispName.."|r", phpColor..phpStatus.."|r");
                GameTooltip:AddLine("<"..dispClass..">", nextColor.r, nextColor.g, nextColor.b);
                GameTooltip:AddLine("|cffffffff<"..dispTeam..">|r");
                GameTooltip:AddLine("|cffacacacSign-up: "..dispTime.."|r");
        else
                charID = tonumber(strsub(id, 2));
                u = 1;
                dataID = 0;
                for i=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID]["queue"]) do
                        dispName = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID]["queue"][i]["name"];
                        dispTime = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID]["queue"][i]["timestamp"];
                        dispClass = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID]["queue"][i]["class"];
                        tipClass = dispClass;
                        if (tipClass == "Death Knight") then
                        		tipClass = "DeathKnight";
                        end;
                        if (strsub(dispName, 1, 1) == "*") then
                                dispName = strsub(dispName, 2);
                        end;
                        if (u == charID+RIMRaid_QueueOffset) then
                                if not phpStatusCheck[dispName] then
                                        phpColor = "|cffa7a7a7";
                                        phpStatus = RIML[RIM_Locale]["Offline"];
                                elseif (phpStatusCheck[dispName] == RIML[RIM_Locale]["Online"]) then
                                        phpColor = "|cffffff00";
                                        phpStatus = RIML[RIM_Locale]["Online"];
                                elseif (phpStatusCheck[dispName] == RIML[RIM_Locale]["In Group"]) then
                                        phpColor = "|cff00ff7d";
                                        phpStatus = RIML[RIM_Locale]["In Group"];
                                else
                                        phpColor = "|cff00e0ff";
                                        phpStatus = phpStatusCheck[dispName];
                                end;
                                nextColor = RAID_CLASS_COLORS[string.upper(tipClass)];
                                GameTooltip:AddDoubleLine("|cffffffff"..dispName.."|r", phpColor..phpStatus.."|r");
                                GameTooltip:AddLine("<"..dispClass..">", nextColor.r, nextColor.g, nextColor.b);
                                GameTooltip:AddLine("|cffacacacSign-up: "..dispTime.."|r");
                        end;
                        u = u + 1;
                end;
        end;
        GameTooltip:Show();
end;

ParseIncomingData = function()
        if (arg1 ~= "DBWFT") then return end;
--        RIM.Print("echo", nil, "("..arg4..") --> "..arg2);
        if (arg2 == "StartRaidList") then
                if LockLeader then return end;
                if (arg4 == phpLeader) then
                        LockLeader = phpLeader;
                        phpReceive = {
                                ["raids"] = { },
                                ["updates"] = { },
                                ["time"] = ""
                        }
                        phpBcLockout = 60;
                        phpRaidSave[RIM_myServer][RIM_myGuild]["old"] = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"];
--                        phpRaidSave[RIM_myServer][RIM_myGuild]["raids"] = { };
--                        RIMRaid_UIRaidIDText:SetText(RIML[RIM_Locale]["Data Updating. Please wait...."]);
--                        RIMRaid_TeamIDText:SetText(RIML[RIM_Locale]["Data Updating. Please wait...."]);
                        RIMRaider_MainQueueScrollLeft:Disable();
                        RIMRaider_MainQueueScrollRight:Disable();
                        RIM_SyncMin = 1;
                end;
        elseif (strsub(arg2, 1, 8) == "MaxSend ") then
                if (arg4 == LockLeader) then
                        RIM_SyncMax = strsub(arg2, 9);
                end;
        elseif (arg2 == "EndRaidList") then
                if (arg4 == LockLeader) then
                        phpRaidSave[RIM_myServer][RIM_myGuild]["raids"] = nil;
                        phpRaidSave[RIM_myServer][RIM_myGuild]["old"] = nil;
                        LockLeader = nil;
                        phpBcLockout = 0;
                        phpRaidSave[RIM_myServer][RIM_myGuild]["raids"] = phpReceive["raids"];
                        phpRaidSave[RIM_myServer][RIM_myGuild]["file_stamp"] = phpReceive["file_stamp"];
                        RIM_SyncMin = RIM_SyncMin + 1;
                        if (LockLeader == UnitName("player")) then
                        		RIM.CalendarMatchmaker();
                        end;
                end;
        elseif (strsub(arg2, 1, 2) == "UT") then
                if (arg4 == LockLeader) then
                        updateTime = strsub(arg2, 3);
                        phpReceive["file_stamp"] = updateTime;
                        RIM_SyncMin = RIM_SyncMin + 1;
                end;
        elseif (strsub(arg2, 1, 2) == "RN") then
                if (arg4 == LockLeader) then
                        nextDate, nextTime, nextLocation = strsplit("~", arg2);
                        nextDate = strsub(nextDate, 3);
                        nextRaid = {
                                ["start_time"] = nextTime,
                                ["date"] = nextDate,
                                ["location"] = nextLocation,
                                ["DeathKnight"] = { },
                                ["Druid"] = { },
                                ["Hunter"] = { },
                                ["Mage"] = { },
                                ["Paladin"] = { },
                                ["Priest"] = { },
                                ["Rogue"] = { },
                                ["Shaman"] = { },
                                ["Warlock"] = { },
                                ["Warrior"] = { },
                                ["queue"] = { },
                        }
                        tinsert(phpReceive["raids"], nextRaid);
                        nextRaidID = getn(phpReceive["raids"]);
                        phpBcLockout = 60;
                        RIM_SyncMin = RIM_SyncMin + 1;
                end;
        elseif (strsub(arg2, 1, 2) == "RC") then
                if (arg4 == LockLeader) then
                        nextName, nextClass, tooltipClass, nextTimestamp, nextTeam, access_type = strsplit("~", arg2);
                        nextName = strsub(nextName, 3);
                        nextRaid = {
                                ["name"] = nextName,
                                ["class"] = tooltipClass,
                                ["timestamp"] = nextTimestamp,
                                ["team_name"] = nextTeam,
                                ["access_type"] = access_type,
                        }
                        tinsert(phpReceive["raids"][nextRaidID][nextClass], nextRaid);
--tinsert(phpRaidSave["DebugRecv"], "RC"..Ncomment..Nname.."~"..nonPhpClasses[z].."~"..Nclass.."~"..Ntimestamp.."~"..Nteam.."~"..Naccess);
                        phpBcLockout = 60;
                        RIM_SyncMin = RIM_SyncMin + 1;
                end;
        end;

        if (arg4 == UnitName("player")) then return end;
        if (strsub(arg2, 1, 2) == "VR") then
                checkVer = tonumber(strsub(arg2, 3));
                if (checkVer > RIM_NewVersion) then
                        RIM_NewVersion = checkVer;
                        RIMFu:UpdateText();
                end;
                if (RIM_TempDisplayVersion > 0) then
                        RIM.Print("echo", nil, arg4..": v"..checkVer);
                end;
        elseif (strsub(arg2, 1, 1) == "V") then
                RIM.Print("hidden", "guild", "VR"..RIMOptions["Version"]);
                checkVer = tonumber(strsub(arg2, 2));
                if (checkVer > RIM_NewVersion) then
                        RIM_NewVersion = checkVer;
                        RIMFu:UpdateText();
                end;
        elseif (strsub(arg2, 1, 10) == "CheckTime ") then
                checkTime = strsub(arg2, 11);
                if (phpLeader == UnitName("player")) then
                        if (tonumber(checkTime) > tonumber(phpRaid_Data["file_stamp"])) then
                                RIM.Print("hidden", "guild", "NewLead "..arg4);
                                phpLeader = arg4;
                        else
                                RIM.Print("hidden", "guild", "phpLeader");
                                if (getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) > 0) then
                                        RIM.SendBroadcast2();
                                else
                                        RIM.SendBroadcast();
                                end;
                        end;
                end;
        elseif (strsub(arg2, 1, 8) == "NewLead ") then
                phpLeader = strsub(arg2, 9);
                if RIMOptions["phpDebug"] then
                        RIM.Print("echo", nil, RIML[RIM_Locale]["New"].." phpLeader: "..phpLeader);
                end;
                if (phpLeader == UnitName("player")) then
                        if (getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) > 0) then
                                RIM.SendBroadcast2();
                        else
                                RIM.SendBroadcast();
                        end;
                end;
        elseif (strsub(arg2, 1, 9) == "phpLeader") then
                phpLeader = arg4;
                if RIMOptions["phpDebug"] then
                        RIM.Print("echo", nil, RIML[RIM_Locale]["New"].." phpLeader: "..arg4);
                end;
                if (phpLeader == UnitName("player")) then
                        if (getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) > 0) then
                                RIM.SendBroadcast2();
                        else
                                RIM.SendBroadcast();
                        end;
                end;
        elseif (strsub(arg2, 1, 9) == "LeadTime ") then
                phpLeaderTimer = 20;
                RIM.Print("hidden", "guild", "LeadTimeR "..phpRaid_Data["file_stamp"]);
                tinsert(phpLeadList, phpRaid_Data["file_stamp"]);
                tinsert(phpLeadList, strsub(arg2, 10));
                tempPhpSenddate = 1;
        elseif (strsub(arg2, 1, 10) == "LeadTimeR ") then
                tinsert(phpLeadList, strsub(arg2, 11));
        elseif (strsub(arg2, 1, 11) == "LeadRandom ") then
                tinsert(phpLeadList, strsub(arg2, 12).."-"..arg4);
        end;
end;

SendBroadcast2 = function()
        nextItem = {
                ["message"] = "StartRaidList",
                ["sendType"] = "hidden",
                ["channel"] = "guild"
        }
        RIM_SyncMax = 1;
        tinsert(RIMBroadcastQueue, nextItem);
        nextItem = {
                ["message"] = "UT"..phpRaidSave[RIM_myServer][RIM_myGuild]["file_stamp"],
                ["sendType"] = "hidden",
                ["channel"] = "guild"
        }
        RIM_SyncMax = RIM_SyncMax + 1;
        tinsert(RIMBroadcastQueue, nextItem);
        for i=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) do
                Ndate = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["date"];
                Ntime = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["start_time"];
                Nlocation = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["location"];
                nextItem = {
                        ["message"] = "RN"..Ndate.."~"..Ntime.."~"..Nlocation,
                        ["sendType"] = "hidden",
                        ["channel"] = "guild"
                }
                RIM_SyncMax = RIM_SyncMax + 1;
                tinsert(RIMBroadcastQueue, nextItem);
                for z=1,11 do
                        if (getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]]) > 0) then
                                for u=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]]) do
                                        Nname = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]][u]["name"];
                                        Nclass = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]][u]["class"];
                                        Ntimestamp = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]][u]["timestamp"];
                                        Nteam = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]][u]["team_name"];
                                        Naccess = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]][u]["access_type"];
                                        if not Nteam then
                                                Nteam = "None";
                                        end;
                                        myTime = strsub(Ntimestamp, 11, 12)..strsub(Ntimestamp, 14, 15)..strsub(Ntimestamp, 17, 20)..strsub(Ntimestamp, 22, 23)..strsub(Ntimestamp, 25, 26);
                                        if (Nname ~= "") then
                                                nextItem = {
                                                        ["message"] = "RC"..Nname.."~"..nonPhpClasses[z].."~"..Nclass.."~"..Ntimestamp.."~"..Nteam.."~"..Naccess;
                                                        ["sendType"] = "hidden",
                                                        ["channel"] = "guild"
                                                }
                                                RIM_SyncMax = RIM_SyncMax + 1;
                                                tinsert(RIMBroadcastQueue, nextItem);
                                        end;
                                        Nname = "";
                                        Nclass = "";
                                        Ntimestamp = "";
                                        Naccess = "";
                                end;
                        end;
                end;
        end;
        nextItem = {
                ["message"] = "EndRaidList",
                ["sendType"] = "hidden",
                ["channel"] = "guild"
        }
        RIM_SyncMax = RIM_SyncMax + 1;
        tinsert(RIMBroadcastQueue, nextItem);
        RIM.Print("hidden", "guild", "MaxSend "..RIM_SyncMax);
end;

SendBroadcast = function()
        nextItem = {
                ["message"] = "StartRaidList",
                ["sendType"] = "hidden",
                ["channel"] = "guild"
        }
        RIM_SyncMax = 1;
        tinsert(RIMBroadcastQueue, nextItem);
        nextItem = {
                ["message"] = "UT"..phpRaid_Data["file_stamp"],
                ["sendType"] = "hidden",
                ["channel"] = "guild"
        }
        RIM_SyncMax = RIM_SyncMax + 1;
        tinsert(RIMBroadcastQueue, nextItem);
        for i=0,getn(phpRaid_Data["raids"]) do
                Ndate = phpRaid_Data["raids"][i]["date"];
                Ntime = phpRaid_Data["raids"][i]["start_time"];
                Nlocation = phpRaid_Data["raids"][i]["location"];
                nextItem = {
                        ["message"] = "RN"..Ndate.."~"..Ntime.."~"..Nlocation,
                        ["sendType"] = "hidden",
                        ["channel"] = "guild"
                }
                RIM_SyncMax = RIM_SyncMax + 1;
                tinsert(RIMBroadcastQueue, nextItem);
                for z=1,11 do
                        if phpRaid_Data["raids"][i][phpClasses[z]][0] then
                                for u=0,getn(phpRaid_Data["raids"][i][phpClasses[z]]) do
                                        Nname = phpRaid_Data["raids"][i][phpClasses[z]][u]["name"];
                                        Nclass = phpRaid_Data["raids"][i][phpClasses[z]][u]["class"];
                                        Ntimestamp = phpRaid_Data["raids"][i][phpClasses[z]][u]["timestamp"];
                                        Ncomment = phpRaid_Data["raids"][i][phpClasses[z]][u]["comment"];
                                        Nteam = phpRaid_Data["raids"][i][phpClasses[z]][u]["team_name"];
                                        Naccess = phpRaid_Data["raids"][i][phpClasses[z]][u]["access_type"];
                                        if not Nteam then
                                                Nteam = "None";
                                        end;
                                        if (Ncomment ~= "") then
                                                Ncomment = "*";
                                        end;
                                        myTime = strsub(Ntimestamp, 11, 12)..strsub(Ntimestamp, 14, 15)..strsub(Ntimestamp, 17, 20)..strsub(Ntimestamp, 22, 23)..strsub(Ntimestamp, 25, 26);
                                        if (Nname ~= "") then
                                                nextItem = {
                                                        ["message"] = "RC"..Ncomment..Nname.."~"..nonPhpClasses[z].."~"..Nclass.."~"..Ntimestamp.."~"..Nteam.."~"..Naccess;
                                                        ["sendType"] = "hidden",
                                                        ["channel"] = "guild"
                                                }
--tinsert(phpRaidSave["DebugSent"], "RC"..Ncomment..Nname.."~"..nonPhpClasses[z].."~"..Nclass.."~"..Ntimestamp.."~"..Nteam.."~"..Naccess);
                                                RIM_SyncMax = RIM_SyncMax + 1;
                                                tinsert(RIMBroadcastQueue, nextItem);
                                        end;
                                        Nname = "";
                                        Nclass = "";
                                        Ntimestamp = "";
                                        Ncomment = "";
                                        Naccess = "";
                                end;
                        end;
                end;
        end;
        nextItem = {
                ["message"] = "EndRaidList",
                ["sendType"] = "hidden",
                ["channel"] = "guild"
        }
        RIM_SyncMax = RIM_SyncMax + 1;
        tinsert(RIMBroadcastQueue, nextItem);
        RIM.Print("hidden", "guild", "MaxSend "..RIM_SyncMax);
end;

ParseSystemMsg = function()
--        RIM.Print("echo", nil, arg1);
        checkName = nil;
        local _,_,checkName = strfind(arg1, RIML[RIM_Locale]["(.+) has come online.$"]);
        if checkName then
                checkName = strsub(checkName, 10, strfind(checkName, "|h")-1);
                if phpStatusCheck[checkName] and (phpStatusCheck[checkName] ~= RIML[RIM_Locale]["In Group"]) then
                        phpStatusCheck[checkName] = RIML[RIM_Locale]["Online"];
                        if (RIMOptions["AutoInvite"] == 1) and (RIM_AutoInviteActive) and (RIM_InviteTimeout) then
                                for z=1,9 do
                                        className = nonPhpClasses[z];
                                        for i=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIM_AutoInviteActive][className]) do
                                                dispName = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIM_AutoInviteActive][className][i]["name"];
                                                dispTeam = phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIM_AutoInviteActive][className][i]["team_name"];
                                                if (RIMRaid_DisplayTeam == "Any") or (RIMRaid_DisplayTeam == dispTeam) then
                                                        if (strsub(dispName, 1, 1) == "*") then
                                                                dispName = strsub(dispName, 2);
                                                        end;
                                                        if (strsub(dispName, 1, 1) == "*") then
                                                                dispName = strsub(dispName, 2);
                                                        end;
                                                        if (dispName == checkName) then
                                                                InviteUnit(checkName);
                                                                if (GetNumRaidMembers == 0) then
                                                                        checkConvert = 0;
																		for z=1,10 do
                																checkConvert = checkConvert + getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][RIMRaid_RaidID][nonPhpClasses[z]]);
        																end;
        																if (checkConvert > 5) then
																		   		RIM_ConvertToRaid = 1;
        																end;
                                                                end;
                                                        end;
                                                end;
                                        end;
                                end;
                        end;
                end;
        end;
        checkName = nil;
        local _,_,checkName = strfind(arg1, RIML[RIM_Locale]["(.+) has gone offline.$"]);
        if checkName then
                if phpStatusCheck[checkName] and (phpStatusCheck[checkName] ~= RIML[RIM_Locale]["In Group"]) then
                        phpStatusCheck[checkName] = nil;
                end;
        end;
        checkName = nil;
        local _,_,checkName = strfind(arg1, RIML[RIM_Locale]["(.+) joins the party.$"]);
        if checkName then
                phpStatusCheck[checkName] = RIML[RIM_Locale]["In Group"];
        end;
        checkName = nil;
        local _,_,checkName = strfind(arg1, RIML[RIM_Locale]["(.+) has joined the raid group.$"]);
        if checkName then
                phpStatusCheck[checkName] = RIML[RIM_Locale]["In Group"];
        end;
        checkName = nil;
        local _,_,checkName = strfind(arg1, RIML[RIM_Locale]["(.+) leaves the party.$"]);
        if checkName then
                if phpStatusCheck[checkName] and (phpStatusCheck[checkName] == RIML[RIM_Locale]["In Group"]) then
                        phpStatusCheck[checkName] = RIML[RIM_Locale]["Online"];
                end;
        end;
        checkName = nil;
        local _,_,checkName = strfind(arg1, RIML[RIM_Locale]["(.+) has left the raid group.$"]);
        if checkName then
                if phpStatusCheck[checkName] and (phpStatusCheck[checkName] == RIML[RIM_Locale]["In Group"]) then
                        phpStatusCheck[checkName] = RIML[RIM_Locale]["Online"];
                end;
        end;
        if (arg1 == RIML[RIM_Locale]["Your group has been disbanded."]) then
                for nextName,nextStatus in pairs(phpStatusCheck) do
                        if (nextStatus == RIML[RIM_Locale]["In Group"]) then
                                phpStatusCheck[nextName] = RIML[RIM_Locale]["Online"];
                        end;
                end;
        end;
        if (arg1 == RIML[RIM_Locale]["You leave the group."]) then
                for nextName,nextStatus in pairs(phpStatusCheck) do
                        if (nextStatus == RIML[RIM_Locale]["In Group"]) then
                                phpStatusCheck[nextName] = RIML[RIM_Locale]["Online"];
                        end;
                end;
        end;
        if (arg1 == RIML[RIM_Locale]["You have left the raid group."]) then
                for nextName,nextStatus in pairs(phpStatusCheck) do
                        if (nextStatus == RIML[RIM_Locale]["In Group"]) then
                                phpStatusCheck[nextName] = RIML[RIM_Locale]["Online"];
                        end;
                end;
        end;
        if (arg1 == RIML[RIM_Locale]["You have joined a raid group."]) then
                phpStatusCheck[UnitName("player")] = RIML[RIM_Locale]["In Group"];
        end;
        if (RIMRaider_Main:IsShown()) then
                RIM.DisplayRaiders(RIMRaid_RaidID, RIMRaid_DisplayTeam, 1);
                RIM.DisplayQueue(RIMRaid_RaidID, 0);
        end;
end;

CalendarMatchmaker = function()
		for i=1,getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) do
				for z=1,11 do
						if (phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]]["name"] == UnitName("player")) then
								if (phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i][nonPhpClasses[z]]["access_type"] ~= "User") then
										RIM.Print("echo", nil, "Owner or Admin for "..phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["location"]);
										local nextMonth, nextDay, nextYear = split(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["date"], "/");
										local monthOffset = tonumber(nextMonth)-tonumber(date("%m"));
										if (tonumber(date("%y")) < tonumber(nextYear)) then
												monthOffset = monthOffset + 12;
										end;  
										local numEvents = CalendarGetNumDayEvents(monthOffset, tonumber(nextDay));
										for u=1,numEvents do
												local title, hour, minute, calendarType, sequenceType, eventType, texture, modStatus, invitedBy = CalendarGetDayEvent(monthOffset, tonumber(nextDay), u);
												RIM.Print("echo", nil, title.."-"..hour.."-"..minute.." ("..sequenceType..") "..modStatus);
												RIM.Print("echo", nil, calendarType.."-"..eventType);
												
												if (phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["location"] == title) then
														
												end;
										end;
								else
										RIM.Print("echo", nil, "User for "..phpRaidSave[RIM_myServer][RIM_myGuild]["raids"][i]["location"]);
								end;
						end;
				end;
		end;
end;

TimerTick = function(elapsed)
		if not RIM_myGuild and GetGuildInfo("player") then
				RIM.SendInitial();
		end;
        if (RIMRaider_Main:IsShown()) then
        		if not RIM_UpdateColors then
        				RIM_UpdateColors = elapsed;
        		else
        				RIM_UpdateColors = RIM_UpdateColors + elapsed;
        		end;
        		if (RIM_UpdateColors >= 15) then
		                RIM.DisplayRaiders(RIMRaid_RaidID, RIMRaid_DisplayTeam);
        		        RIM.DisplayQueue(RIMRaid_RaidID, 0);
        		        RIM_UpdateColors = 0;
        		end;
        end;
        if (getn(RIMBroadcastQueue) > 0) then
                if not LRBroadcastTimer then
                        LRBroadcastTimer = elapsed;
                else
                        LRBroadcastTimer = LRBroadcastTimer + elapsed;
                end;
                if (LRBroadcastTimer >= RIMOptions["BroadcastThrottle"]) then
                        nextLocation = RIMBroadcastQueue[1]["message"];
                        sendType = RIMBroadcastQueue[1]["sendType"];
                        channel = RIMBroadcastQueue[1]["channel"];
                        RIM.Print(sendType, channel, nextLocation);
                        tremove(RIMBroadcastQueue, 1);
                        LRBroadcastTimer = LRBroadcastTimer - RIMOptions["BroadcastThrottle"];
                end;
        end;
        if (phpBcLockout > 0) then
                phpBcLockout = phpBcLockout - elapsed;
                if (phpBcLockout <= 0) then
                        LockLeader = nil;
                        phpRaidSave[RIM_myServer][RIM_myGuild]["raids"] = phpRaidSave[RIM_myServer][RIM_myGuild]["old"];
                        phpRaidSave[RIM_myServer][RIM_myGuild]["old"] = nil;
                end;
        end;
        if (RIM_TempDisplayVersion > 0) then
                RIM_TempDisplayVersion = RIM_TempDisplayVersion - elapsed;
        end;
        if (phpLeaderTimer > 0) then
                phpLeaderTimer = phpLeaderTimer - elapsed;
                if (phpLeaderTimer <= 0) then
                        if (phpLeader == "") and not tempPhpRand then
                                phpLeaderTimer = 20;
                                if not tempPhpSenddate then
                                        RIM.Print("hidden", "guild", "LeadTime "..phpRaid_Data["file_stamp"]);
                                        tinsert(phpLeadList, phpRaid_Data["file_stamp"]);
                                        tempPhpSenddate = 1;
                                else
                                        tempPhpSenddate = nil;
                                        sort(phpLeadList);
                                        if (phpRaid_Data["file_stamp"] == phpLeadList[getn(phpLeadList)]) then
                                                tempPhpRand = math.random(1000);
                                                RIM.Print("hidden", "guild", "LeadRandom "..tempPhpRand);
                                                phpLeadList = { };
                                                tinsert(phpLeadList, tempPhpRand.."-"..UnitName("player"));
                                        else
                                                phpLeadList = { };
                                        end;
                                end;
                        elseif (phpLeader == "") and tempPhpRand then
                                sort(phpLeadList);
                                phpLeader = strsub(phpLeadList[getn(phpLeadList)], strfind(phpLeadList[getn(phpLeadList)], "-")+1);
                                if RIMOptions["phpDebug"] then
                                        RIM.Print("echo", nil, RIML[RIM_Locale]["New"].." phpLeader: "..phpLeader);
                                end;
                                if (phpLeader == UnitName("player")) then
                                        if (getn(phpRaidSave[RIM_myServer][RIM_myGuild]["raids"]) > 0) then
                                                RIM.SendBroadcast2();
                                        else
                                                RIM.SendBroadcast();
                                        end;
                                end;
                                tempPhpRand = nil;
                                phpLeadList = { };
                        end;
                end;
        end;
        if (RIM_InviteTimeout) then
                RIM_InviteTimeout = RIM_InviteTimeout - elapsed;
                if (RIM_InviteTimeout < 0) then
                        RIM_InviteTimeout = nil;
                end;
        end;
        if (RIM_AutoPromoteTimer > 0) and (getn(RIM_AutoPromote) > 0) then
		        RIM_AutoPromoteTimer = RIM_AutoPromoteTimer - elapsed;
		        if (GetNumRaidMembers() > 0) and IsRaidLeader() then
		        		for q=1,GetNumRaidMembers() do
		        				for u=1,getn(RIM_AutoPromote) do
		        						if (UnitName("raid"..q) == RIM_AutoPromote[u]) then
		        								PromoteToAssistant(RIM_AutoPromote[u]);
		        								tremove(RIM_AutoPromote, u);
		        						end;
		        				end;
		        		end;
		        end;
		        if (RIM_AutoPromoteTimer <= 0) then
		        		RIM_AutoPromote = { };
		        end;
		end;
end;

Print = function(type, channel, str)
        if not (str) then
                RIM.Print("echo", nil, RIML[RIM_Locale]["No Message to Print"]);
        else
                if (type == "echo") then
                        if DEFAULT_CHAT_FRAME then
                                str = "|cffff0000WRM:RIM>|r "..str;
                                DEFAULT_CHAT_FRAME:AddMessage(str);
                        end;
                else
                        if ((type == "party") or (type == "guild") or (type == "raid") or (type == "officer") or (type == "say")) then
                                SendChatMessage(str, string.upper(type));
                        elseif (type == "whisper") then
                                SendChatMessage(str, "WHISPER", nil, channel);
                        elseif (type == "channel") then
                                SendChatMessage(str, "CHANNEL", nil, GetChannelName(channel));
                        elseif (type == "hidden") then
                        		if (string.upper(channel) == "GUILD") then
                        				if IsInGuild() then
                                				SendAddonMessage("DBWFT", str, string.upper(channel));
                                		else
                                				SendAddonMessage("DBWFT", str, "WHISPER", UnitName("Player"));
                                		end;
                                else
                                		SendAddonMessage("DBWFT", str, string.upper(channel));
                                end;
                        else
                                RIM.Print("echo", nil, RIML[RIM_Locale]["Invalid Send Type"]);
                        end;
                end;
        end;
end;

}
